function InitializeProductSelection(productNumberField,isProductSelected=false,successCallback) {

    var productnNumberFieldSelector = "#" + productNumberField;    

    if (typeof(modelNameLabel) === "undefined" || modelNameLabel == null || modelNameLabel == "")
        modelNameLabel = "Model Name";
	if (typeof(modelNamePlaceHolder) === "undefined" || modelNamePlaceHolder == null || modelNamePlaceHolder == "")
		modelNamePlaceHolder = "Begin typing to search..."

    $('table tbody tr:eq(1) td:eq(0)').prepend(
        $(document.createElement('div')).prop({
            id: 'newdiv',
            name: 'newdiv'
        })
    );

    $("#newdiv").addClass("info required").prepend('<label for="flk_productmodelnumber" id="flk_productmodelnumber_label" class="field-label">' + modelNameLabel + '</label><div class="validators"><span id="MaximumLengthValidatorflk_productmodelnumber" style="visibility:hidden;">*</span></div><div class="control"><input name="flk_productmodelnumber" type="text" autocomplete="off" maxlength="100" id="flk_productmodelnumber" class="text form-control model autocomplete ui-autocomplete-input" placeholder="' + modelNamePlaceHolder + '"><select id="modelSelect" class="text" name="modelSelect" style="display: none;"></select></div>');



    
	// Autocomplete model :: BEGIN
    var availableModels;
     $.getJSON("/products.json", function(products) {
		availableModels = availableModels || [];
		  for (var i = 0; i < products.length; i++) {
			  availableModels.push({
                                        value: products[i].pid,
                                        label: products[i].name
                                    });
		  }
          	 
	 //Added this code for QR Code product selection
			if(isProductSelected){
				var selectedProdId = $("#flk_productnumberselected").length?$("#flk_productnumberselected").val():$("#flk_productnumber").val();				
                   //set the selected Product
                $(".autocomplete.model").autocomplete("search",selectedProdId);
                var menu = $(".autocomplete.model").autocomplete("widget");
                $(menu[0].children[0]).click();  
                 //Call Callback function for locking the fields
                if(typeof successCallback === 'function'){
                    successCallback();
                  }
                }else{
                    console.log("No Product Found with given Model Number");
                }	
			  
    });



    $(".autocomplete.model").autocomplete({
        minLength: 3,
        source: function (request, response) {
            //if product is already selected return the match based on the productnumber
            if(isProductSelected){
                response($.grep(availableModels, function (item) {
                    return item.value === request.term; 
                }).slice(0, 1)); // slice to limit results
            
             }else{ 

            const matchReplace = /\W|_|\s|\//g; // Find all special chars \W, underscores _, and spaces \s - globally /g
            const matcher = new RegExp($.ui.autocomplete.escapeRegex(request.term.replace(matchReplace, "")), "i"); // Replace all with empty string for easy compare
            response($.grep(availableModels, function (item) {
                return matcher.test(item.label.replace(matchReplace, "")); // Replace all with empty string for easy compare
            }).slice(0, 10)); // slice to limit results
        }
        },
        select: function (event, ui) {
            // clicks on item
            return updateModel(event, ui);
        },
        focus: function (event, ui) {
            // tabs to next inpout box
            return updateModel(event, ui);
        },
        change: function (event, ui) {
            // arrows through list
            return updateModel(event, ui);
        }
    });



    function updateModel(event, ui) {
        var $modelSelect = $("#modelSelect");
        $modelSelect.empty();
        if (ui.item != null) {
            $('.autocomplete.model').val(ui.item.label);
            $modelSelect.append('<option value="' + ui.item.value + '" >' + ui.item.label + "</option>");
        } else {
            $('.autocomplete.model').val('');
        }
        $modelSelect.change();

        return false;
    }

    $('#modelSelect').change(function () {

        productName = $('#modelSelect option:selected').text();
        productNumber = $('#modelSelect option:selected').val();
        $(productnNumberFieldSelector).val(productNumber);
        //$("#flk_productmodelnumber").val(productName);
        $(productnNumberFieldSelector).change();
        //$('#modelSelect').hide();

    });
    // Autocomplete model :: END

}

async function getSelectedProductDetails(productNumber) {
    var filterData;
    await $.getJSON("/products.json", function(products) {
       filterData = products.filter(item => item.pid === productNumber);
    });  
 
    return filterData;
 };